<template>
  <div div="signin">
    <div class="login-form">
      <b-card title="Login" tag="article" style="max-width: 20rem;" class="mb-2">
        <div>
          <b-alert :show="hasError" dismissible variant="danger">{{ alertMessage }}</b-alert>
        </div>
        <div>
          <b-form-input type="text" placeholder="Username" v-model="username" />
          <div class="mt-2"></div>

          <b-form-input type="password" placeholder="Password" v-model="password" />
          <div class="mt-2"></div>
        </div>

        <b-button v-on:click="processLogin" variant="primary">Login</b-button>

        <hr class="my-4" />

      </b-card>
    </div>
    <div class="wrapper">
      <div class="arrow">
        <b-button v-on:click="goToAdminLogin" variant="link">Admin?</b-button>
      </div>
    </div>
  </div>
</template>

<script>
import { AXIOS } from "./http-common";

export default {
  name: "SignIn",
  data() {
    return {
      username: "",
      password: "",
      hasError: false,
      alertMessage: "Request error"
    };
  },
  methods: {
    countDownChanged(dismissCountDown) {
      this.dismissCountDown = dismissCountDown;
    },
    goToAdminLogin() {
      this.$router.push("/admin/login/");
    },
    showAlert() {
      this.dismissCountDown = this.dismissSecs;
    },
    processLogin() {
      AXIOS.post(
        `/auth/login`,
        { login: this.$data.username, password: this.$data.password },
        { withCredentials: true }
      )
        .then(
          response => {
            console.log(response);
            console.log(response.headers["set-cookie"]);
            this.$store.dispatch("login", {
              token: this.$cookies.get("token"),
              role: response.data.unit
                ? "ROLE_UNIT_" + response.data.unit
                : "ROLE_GLOBAL",
              username: response.data.name
            });
            this.$router.push("/");
            this.hasError = false;
          },
          error => {
            this.$data.alertMessage =
              error.response.data.length < 150
                ? error.response.data
                : "Request error. Please, report this error website owners";
            this.hasError = true;
            console.log(error);
          }
        )
        .catch(e => {
          console.log(e);
          this.showAlert(
            "Server error. Please, report this error website owners"
          );
          this.hasError = true;
        });
    }
  }
};
</script>

<style>
.login-form {
  margin-left: 38%;
  margin-top: 50px;
}

.wrapper {
  width: 100px;
  height: 100px;
  position: relative;
}

.arrow {
  width: 10px;
  height: 10px;
  position: absolute;
  right: 0px;
  bottom: 0px;
}
</style>